package edu.nju.controller;
import edu.nju.entities.BugDetail;
import edu.nju.service.DataService;
import edu.nju.service.FileService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * @Author JiaWei Xu
 * @Date 2020-12-25 10:40
 * @Email xjwhhh233@outlook.com
 */
@Controller
@RequestMapping(value = "/data")
@CrossOrigin(origins = "*", maxAge = 3600, allowCredentials = "true")
public class DataController {

    @Autowired
    DataService dataService;

    @Autowired
    FileService fileService;

    /**根据caseId获取bug报告
     *
     * @param caseId
     */
    @RequestMapping(value = "/outputByCaseId")
    @ResponseBody
    public List<BugDetail> getBugDetailByCaseId(String caseId) {
        return fileService.exportBugInfo(caseId);
    }


    /**
     * bug数据导入
     * @param zipFile
     * @param jsonFile
     * @param originalCaseId 与目前系统哪个case对应
     * @param cpSerialNum 来自哪个cp
     * @return
     */
    @RequestMapping(value = "/inputFromFile")
    @ResponseBody
    public List<BugDetail> saveBugDetailFromFile(@RequestParam("zipFile") MultipartFile zipFile, @RequestParam("jsonFile") MultipartFile jsonFile, String originalCaseId, String cpSerialNum) {
        return fileService.importBugInfo(zipFile,jsonFile,originalCaseId,cpSerialNum);
    }
}
