package edu.nju.controller;

import edu.nju.entities.ReviewJob;
import edu.nju.service.ReviewAnalyzeService;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;

@Controller
@RequestMapping(value = "/reviewAnalyze")
@CrossOrigin(origins = "*", maxAge = 3600, allowCredentials = "true")
public class ReviewAnalyzeController {
    @Autowired
    ReviewAnalyzeService reviewAnalyzeService;

    @RequestMapping(value = "/analyzeItem")
    @ResponseBody
    public void analyzeItem(String itemId,String reportId,String jobId, HttpServletResponse response){
        try {
            PrintWriter out = response.getWriter();
            JSONObject jsonObject=reviewAnalyzeService.analyzeItem(itemId,reportId,jobId);
            out.print(jsonObject);
            out.flush();
            out.close();
        }catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    //获取众审任务的结果excel
    @RequestMapping(value = "/job/excel" , method = RequestMethod.GET)
    @ResponseBody
    public String getExcel (String jobId){
        String res = reviewAnalyzeService.getExcel(jobId);
        return res==null?"err0r":res;
    }

    @RequestMapping(value = "/job/json", method = RequestMethod.GET)
    @ResponseBody
    public void getJson ( @RequestParam("id") String jobId , HttpServletResponse response){
        try {
            PrintWriter out = response.getWriter();
            JSONObject job = reviewAnalyzeService.getJsonExport(jobId);
            out.print(job);
            out.flush();
            out.close();
        }catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

//    @RequestMapping(value = "/job/json", method = RequestMethod.GET)
//    @ResponseBody
//    public JSONObject getJson ( @RequestParam("id") String jobId , HttpServletResponse response){
//        JSONObject job = reviewAnalyzeService.getJsonExport(jobId);
//        return job;
//    }

    @RequestMapping(value = "/job/crowdReviewGradeToCrowdTest", method = RequestMethod.GET)
    @ResponseBody
    public String crowdReviewGradeToCrowdTest (String jobId , HttpServletResponse response){
        JSONObject result = reviewAnalyzeService.crowdReviewGradeToCrowdTest(jobId);
        return result.toString();
    }




}
