package edu.nju.entities;

import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.PersistenceConstructor;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.List;
import java.util.Set;

/**
 * @Author JiaWei Xu
 * @Date 2020-12-24 15:53
 * @Email xjwhhh233@outlook.com
 */
@Document
public class BugDetail implements java.io.Serializable {

    //bug属性
    @Id
    private String id;
    private String bugCategory;
    private String severity;
    private String recurrent;
    private String bugCreateTime;
    private String bugPage;
    private String title;
    private String bugDescription;
    private String imgUrl;
    private int score;
    private String parent;
    private List<String> children;
    private String root;
    private int goodNum;
    private Set<String> goodWorkerId;
    private int badNum;
    private Set<String> badWorkerId;

    //测试用例属性
    private String testCaseId;
    private String testCaseName;
    private String testCaseFront;
    private String testCaseBehind;
    private String testCaseDescription;
    private String testCaseCreateTime;

    //report属性
    private String reportId;
    private String reportName;
    private String reportCreateTime;
    private String scriptLocation;
    private String reportLocation;
    private String logLocation;
    private String deviceModel;
    private String deviceBrand;
    private String deviceOs;

    //工人属性
    private String workerId;

    //众测任务属性
    private String caseAppName;
    private String casePaperType;
    private String caseTestType;
    private String caseDescription;
    private String caseRequireDoc;


    //原系统中的case_take_id
    private String caseTakeId;
    //与目前系统中的哪个case对应
    private String originalCaseId;

    //cp系统序列号
    private String cpSerialNum;

    public BugDetail(){};

    @PersistenceConstructor
    public BugDetail(String id, String bugCategory, String severity, String recurrent, String bugCreateTime, String bugPage, String title, String bugDescription, String imgUrl, int score, String parent, List<String> children, String root, int goodNum, Set<String> goodWorkerId, int badNum, Set<String> badWorkerId, String testCaseId, String testCaseName, String testCaseFront, String testCaseBehind, String testCaseDescription, String testCaseCreateTime, String reportId, String reportName, String reportCreateTime, String scriptLocation, String reportLocation, String logLocation, String deviceModel, String deviceBrand, String deviceOs, String workerId, String caseAppName, String casePaperType, String caseTestType, String caseDescription, String caseRequireDoc, String caseTakeId, String originalCaseId, String cpSerialNum) {
        this.id = id;
        this.bugCategory = bugCategory;
        this.severity = severity;
        this.recurrent = recurrent;
        this.bugCreateTime = bugCreateTime;
        this.bugPage = bugPage;
        this.title = title;
        this.bugDescription = bugDescription;
        this.imgUrl = imgUrl;
        this.score = score;
        this.parent = parent;
        this.children = children;
        this.root = root;
        this.goodNum = goodNum;
        this.goodWorkerId = goodWorkerId;
        this.badNum = badNum;
        this.badWorkerId = badWorkerId;
        this.testCaseId = testCaseId;
        this.testCaseName = testCaseName;
        this.testCaseFront = testCaseFront;
        this.testCaseBehind = testCaseBehind;
        this.testCaseDescription = testCaseDescription;
        this.testCaseCreateTime = testCaseCreateTime;
        this.reportId = reportId;
        this.reportName = reportName;
        this.reportCreateTime = reportCreateTime;
        this.scriptLocation = scriptLocation;
        this.reportLocation = reportLocation;
        this.logLocation = logLocation;
        this.deviceModel = deviceModel;
        this.deviceBrand = deviceBrand;
        this.deviceOs = deviceOs;
        this.workerId = workerId;
        this.caseAppName = caseAppName;
        this.casePaperType = casePaperType;
        this.caseTestType = caseTestType;
        this.caseDescription = caseDescription;
        this.caseRequireDoc = caseRequireDoc;
        this.caseTakeId = caseTakeId;
        this.originalCaseId = originalCaseId;
        this.cpSerialNum = cpSerialNum;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getBugCategory() {
        return bugCategory;
    }

    public void setBugCategory(String bugCategory) {
        this.bugCategory = bugCategory;
    }

    public String getSeverity() {
        return severity;
    }

    public void setSeverity(String severity) {
        this.severity = severity;
    }

    public String getRecurrent() {
        return recurrent;
    }

    public void setRecurrent(String recurrent) {
        this.recurrent = recurrent;
    }

    public String getBugCreateTime() {
        return bugCreateTime;
    }

    public void setBugCreateTime(String bugCreateTime) {
        this.bugCreateTime = bugCreateTime;
    }

    public String getBugPage() {
        return bugPage;
    }

    public void setBugPage(String bugPage) {
        this.bugPage = bugPage;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getBugDescription() {
        return bugDescription;
    }

    public void setBugDescription(String bugDescription) {
        this.bugDescription = bugDescription;
    }

    public String getImgUrl() {
        return imgUrl;
    }

    public void setImgUrl(String imgUrl) {
        this.imgUrl = imgUrl;
    }

    public int getScore() {
        return score;
    }

    public void setScore(int score) {
        this.score = score;
    }

    public String getParent() {
        return parent;
    }

    public void setParent(String parent) {
        this.parent = parent;
    }

    public List<String> getChildren() {
        return children;
    }

    public void setChildren(List<String> children) {
        this.children = children;
    }

    public String getRoot() {
        return root;
    }

    public void setRoot(String root) {
        this.root = root;
    }

    public Set<String> getGoodWorkerId() {
        return goodWorkerId;
    }

    public int getGoodNum() {
        return goodNum;
    }

    public void setGoodNum(int goodNum) {
        this.goodNum = goodNum;
    }

    public int getBadNum() {
        return badNum;
    }

    public void setBadNum(int badNum) {
        this.badNum = badNum;
    }

    public void setGoodWorkerId(Set<String> goodWorkerId) {
        this.goodWorkerId = goodWorkerId;
    }

    public Set<String> getBadWorkerId() {
        return badWorkerId;
    }

    public void setBadWorkerId(Set<String> badWorkerId) {
        this.badWorkerId = badWorkerId;
    }

    public String getTestCaseId() {
        return testCaseId;
    }

    public void setTestCaseId(String testCaseId) {
        this.testCaseId = testCaseId;
    }

    public String getTestCaseName() {
        return testCaseName;
    }

    public void setTestCaseName(String testCaseName) {
        this.testCaseName = testCaseName;
    }

    public String getTestCaseFront() {
        return testCaseFront;
    }

    public void setTestCaseFront(String testCaseFront) {
        this.testCaseFront = testCaseFront;
    }

    public String getTestCaseBehind() {
        return testCaseBehind;
    }

    public void setTestCaseBehind(String testCaseBehind) {
        this.testCaseBehind = testCaseBehind;
    }

    public String getTestCaseDescription() {
        return testCaseDescription;
    }

    public void setTestCaseDescription(String testCaseDescription) {
        this.testCaseDescription = testCaseDescription;
    }

    public String getTestCaseCreateTime() {
        return testCaseCreateTime;
    }

    public void setTestCaseCreateTime(String testCaseCreateTime) {
        this.testCaseCreateTime = testCaseCreateTime;
    }

    public String getReportId() {
        return reportId;
    }

    public void setReportId(String reportId) {
        this.reportId = reportId;
    }

    public String getReportName() {
        return reportName;
    }

    public void setReportName(String reportName) {
        this.reportName = reportName;
    }

    public String getReportCreateTime() {
        return reportCreateTime;
    }

    public void setReportCreateTime(String reportCreateTime) {
        this.reportCreateTime = reportCreateTime;
    }

    public String getScriptLocation() {
        return scriptLocation;
    }

    public void setScriptLocation(String scriptLocation) {
        this.scriptLocation = scriptLocation;
    }

    public String getReportLocation() {
        return reportLocation;
    }

    public void setReportLocation(String reportLocation) {
        this.reportLocation = reportLocation;
    }

    public String getLogLocation() {
        return logLocation;
    }

    public void setLogLocation(String logLocation) {
        this.logLocation = logLocation;
    }

    public String getDeviceModel() {
        return deviceModel;
    }

    public void setDeviceModel(String deviceModel) {
        this.deviceModel = deviceModel;
    }

    public String getDeviceBrand() {
        return deviceBrand;
    }

    public void setDeviceBrand(String deviceBrand) {
        this.deviceBrand = deviceBrand;
    }

    public String getDeviceOs() {
        return deviceOs;
    }

    public void setDeviceOs(String deviceOs) {
        this.deviceOs = deviceOs;
    }

    public String getWorkerId() {
        return workerId;
    }

    public void setWorkerId(String workerId) {
        this.workerId = workerId;
    }

    public String getCaseAppName() {
        return caseAppName;
    }

    public void setCaseAppName(String caseAppName) {
        this.caseAppName = caseAppName;
    }

    public String getCasePaperType() {
        return casePaperType;
    }

    public void setCasePaperType(String casePaperType) {
        this.casePaperType = casePaperType;
    }

    public String getCaseTestType() {
        return caseTestType;
    }

    public void setCaseTestType(String caseTestType) {
        this.caseTestType = caseTestType;
    }

    public String getCaseDescription() {
        return caseDescription;
    }

    public void setCaseDescription(String caseDescription) {
        this.caseDescription = caseDescription;
    }

    public String getCaseRequireDoc() {
        return caseRequireDoc;
    }

    public void setCaseRequireDoc(String caseRequireDoc) {
        this.caseRequireDoc = caseRequireDoc;
    }

    public String getCaseTakeId() {
        return caseTakeId;
    }

    public void setCaseTakeId(String caseTakeId) {
        this.caseTakeId = caseTakeId;
    }

    public String getOriginalCaseId() {
        return originalCaseId;
    }

    public void setOriginalCaseId(String originalCaseId) {
        this.originalCaseId = originalCaseId;
    }

    public String getCpSerialNum() {
        return cpSerialNum;
    }

    public void setCpSerialNum(String cpSerialNum) {
        this.cpSerialNum = cpSerialNum;
    }
}
